package graphe;

public class UnGraphe
{
	private UnSommet[] sesSommets;
	public String[] sesNomsSommets;
	
	
	public UnGraphe(int telNbSommets)
	{
		sesSommets=new UnSommet[telNbSommets];
		
		// Initialisation
		for(int i=0; i<sesSommets.length; i++)
		{
			sesSommets[i]=new UnSommet();
		}
	}
	
	
	
	public UnSommet[] donneSesSommets() { return sesSommets; }
	public UnSommet donneSommet(int telInd) { return sesSommets[telInd];}
	public int donneNbSommets() { return sesSommets.length; }
	
	public String donneNomSommet(int telIndSommet)
	{
		return sesNomsSommets[telIndSommet];
	}
	
	public void ajouteVoisin(int telIndSommet, int telIndVoisin, int telPoids)
	{
		sesSommets[telIndSommet].ajouteVoisin(telIndVoisin, telPoids);
	}
	
	
	public void afficheToi()
	{
		for(int i=0; i<sesSommets.length; i++)
		{
			System.out.println ("Sommet "+sesNomsSommets[i]);
			UnVoisin leCourant=sesSommets[i].donneSaListeVoisins();
			
			while(leCourant!=null)
			{
				System.out.println ("\t"+
						sesNomsSommets[leCourant.donneSonIndice()]+","+
						leCourant.donneSaValeur());
				leCourant=leCourant.donneSuivant();
			}
		}
	}
	
	public boolean resteSommetNonMarque()
	{
		int leCompteur=0;
		int i=0;
		
		
		while(i!=donneNbSommets())
		{
			if(sesSommets[i].estMarque())
				leCompteur++;
				
			i++;
		}
		
		return (i!=leCompteur);
	}
	
	
	public int donneIndiceSommet(String telSommet)
	{
		int lIndiceSommet;
		boolean trouve=false;
		
		for(lIndiceSommet=0; lIndiceSommet<sesNomsSommets.length && 
													!trouve; lIndiceSommet++)
		{
			if(sesNomsSommets[lIndiceSommet].equalsIgnoreCase(telSommet))
			{
				trouve=true;
			}
		}
		
		return lIndiceSommet-1;
	}
}